'''
Created on 15/09/2016

@author: andre
'''

import numpy as np
from astropy.io import fits
from astropy import wcs

from plot_starlight_fit import plot_starlight_output
import matplotlib.pyplot as plt

################################################################################
def get_wavelength_coordinates(h):
    w = wcs.WCS(h, naxis=[3])
    Nl_obs = h['NAXIS3']
    pix_coords = np.arange(Nl_obs)
    l_obs = w.wcs_pix2world(pix_coords[:, np.newaxis], 0)
    return np.squeeze(l_obs / 1e-10)
################################################################################


################################################################################
def get_center(h):
    w = wcs.WCS(h, naxis=2)
    return np.rint(w.wcs.crpix).astype('int') - 1
################################################################################


f = fits.open('cube_example.fits')

print 'FITS extensions:'
print f.info()
print

h = f['primary'].header

#x, y = get_center(h)
x, y = 25, 25
l_obs = get_wavelength_coordinates(h)

f_obs = f['primary'].data[:, y, x]
f_syn = f['f_syn'].data[:, y, x]
f_wei = f['f_wei'].data[:, y, x]
f_syn = f['f_syn'].data[:, y, x]

popage_base = f['popage_base'].data
popZ_base = f['popZ_base'].data
popx = f['popx'].data[:, y, x]
popmu_cor = f['popmu_cor'].data[:, y, x]
A_V = f['A_V'].data[y, x]
v_0 = f['v_0'].data[y, x]
v_d = f['v_d'].data[y, x]
adev = f['adev'].data[y, x]
chi2 = f['chi2'].data[y, x]
SN_normwin = None

plot_starlight_output(l_obs, f_obs, f_syn, f_wei,
                      popage_base, popZ_base, popx, popmu_cor,
                      A_V, v_0, v_d,
                      SN_normwin, adev, chi2, title='Pixel %d, %d' % (x, y), i_fig=1)


print 'average log age (light weighted):'
popage_base = f['popage_base'].data
popx__jyx = f['popx'].data

log_age__j = np.log10(popage_base)
norm__yx = popx__jyx.sum(axis=0)
mask = (norm__yx == 0.0)
norm__yx = np.ma.array(norm__yx, mask=mask)

at_flux__yx = (popx__jyx * log_age__j[:, np.newaxis, np.newaxis]).sum(axis=0) / norm__yx

plt.figure(2)
plt.imshow(at_flux__yx)
plt.colorbar()
plt.title('Average log age')
plt.show()

